﻿using Hotline.Share.Dtos.Order;
using Sharing.Province.HuiJu.Send;

namespace Sharing.Api
{
    /// <summary>
    /// 
    /// </summary>
    public interface IProvinceService
    {
        /// <summary>
        /// 数据处理
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        Task<SubmitCaseInfo> InitData(OrderDto dto);

        /// <summary>
        /// 派单是判断需要往第三方推送数据
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        Task OrderDispatch(OrderFlowDto dto);

        /// <summary>
        /// 服务工单回访评价
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        Task SubmitVisitInfo(PublishVisitDto dto);

        /// <summary>
        /// 服务工单处理
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        Task SubmitCaseProcess(OrderFlowDto dto);

        /// <summary>
        /// 服务工单结果
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        Task SubmitCaseResult(OrderFlowDto dto);

        /// <summary>
        /// 服务工单拓展信息
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        Task SubmitCaseExtends(OrderDto dto);

        /// <summary>
        /// 附件处理
        /// </summary>
        /// <param name="dto"></param>
        /// <param name="CaseSerial">工单编号或者督办编号</param>
        /// <param name="CliengGuid">附件</param>
        /// <param name="AreaCode">区域Code</param>
        /// <returns></returns>
        Task FileData(List<Hotline.Share.Dtos.File.FileDto> dto, string CaseSerial, string CliengGuid, string AreaCode);
    }
}
