﻿namespace Sharing.DataExchange.Dtos
{
    public class DeReponse
    {
        /// <summary>
        /// 状态
        /// </summary>
        public string code { get; set; }

        /// <summary>
        /// 描述
        /// </summary>
        public string msg { get; set; }

        /// <summary>
        /// 数据
        /// </summary>
        public string data { get; set; }

        /// <summary>
        /// 成功
        /// </summary>
        /// <param name="data"></param>
        /// <param name="description"></param>
        /// <returns></returns>
        public static DeReponse Success(string data, string? description = "")
        {
            return new DeReponse
            {
                code = "1",
                data = data,
                msg = (description ?? "您已成功提交数据！")
            };
        }

        /// <summary>
        /// 失败
        /// </summary>
        /// <param name="code"></param>
        /// <param name="description"></param>
        /// <returns></returns>
        public static DeReponse Failed(string? code = "0", string? description = "")
        {
            return new DeReponse
            {
                code = code,
                msg = (description ?? "接口调用失败！")
            };
        }

    }
}
