﻿using Sharing.Enterprise.Dtos;
using Sharing.Enterprise.Dtos.Receive;
using Sharing.Enterprise.Dtos.Send;

namespace Sharing.Enterprise
{
    public interface IEnterprisePusherProvider
    {
        /// <summary>
        /// 企业查询
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<EnterpriseResponse> SelectEnterpriseListAsync(SelectEnterpriseListRequest request, CancellationToken cancellationToken);

        /// <summary>
        /// 数据推送
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<EnterpriseResponse> PushWorkOrderSendAsync(PushWorkOrderRequest request, CancellationToken cancellationToken);

        /// <summary>
        /// 数据撤单
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        Task<EnterpriseResponse> PushWorkOrderCancelAsync(CancelWorkOrderRequest request, CancellationToken cancellationToken);
    }
}
