﻿using DotNetCore.CAP;
using MapsterMapper;
using MediatR;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.DependencyInjection;
using Sharing.Province.Dtos;
using Sharing.Province.Dtos.HuiJu.Send;
using Sharing.Province.Dtos.XieTong.Receive;
using Sharing.Province.Extensions;
using Sharing.Province.XieTong.Knowledge;
using Sharing.WebCore;
using XF.Domain.Repository;

namespace Sharing.Province.Controllers
{
    public class ProvinceController : BaseController
    {
        private readonly IChannelConfigurationManager _channelConfigurationManager;
        private readonly PusherProvider _pusherProvider;
        private readonly ICapPublisher _capPublisher;
        private readonly IMapper _mapper;
        private readonly IMediator _mediator;
        private readonly IRepository<GetKnowledgeInfoSend> _getKnowledgeInfoSendRepository;
        private readonly XieTongClient _xieTongClient;
        private readonly IServiceScopeFactory _scopeFactory;

        public ProvinceController(IChannelConfigurationManager channelConfigurationManager, PusherProvider pusherProvider,
            ICapPublisher capPublisher, IMapper mapper, IMediator mediator, IRepository<GetKnowledgeInfoSend> getKnowledgeInfoSendRepository, XieTongClient xieTongClient
            , IServiceScopeFactory scopeFactory)
        {
            _channelConfigurationManager = channelConfigurationManager;
            _pusherProvider = pusherProvider;
            _capPublisher = capPublisher;
            _mapper = mapper;
            _mediator = mediator;
            _getKnowledgeInfoSendRepository = getKnowledgeInfoSendRepository;
            _xieTongClient = xieTongClient;
            _scopeFactory = scopeFactory;
        }

        [HttpGet("test")]
        [AllowAnonymous]
        public async Task<string> Test()
        {

            var a = _channelConfigurationManager.GetConfigurationProvince();
            var b = _channelConfigurationManager.GetConfigurationEnterprise();
            var c = _channelConfigurationManager.GetConfigurationCityHandOver();
            var d = _channelConfigurationManager.GetConfigurationCityCode();
            //var pusher = _pusherProvider.CreatePusher(_channelConfigurationManager);
            //await pusher.PushOrderCreatedAsync(new SubmitCaseInfoRequest(), HttpContext.RequestAborted);
            //var a = _channelConfigurationManager.GetConfigurationProvince().HuiJu;

            //Reponse.Success();
            //Reponse.Failed("");

            //using var scope = _scopeFactory.CreateScope();
            //var provider = scope.ServiceProvider;
            //var channelconfigManager = provider.GetRequiredService<IChannelConfigurationManager>();

            //var configProvince = channelconfigManager.GetConfigurationProvince();

            //string strToken =await _xieTongClient.GetTokenAsync(HttpContext.RequestAborted);
            //var dto = new GetCaseMaterialInfoModel()
            //{
            //    CaseSerial = "1111111111",
            //    MaterialType = "10",
            //    CliengGuid = "22222222",
            //    AreaCode = "510100"
            //};
            //var token = new ClientInfo(configProvince.ClientId, configProvince.ClientSecret);

            //var model = new GetCaseMaterialInfoRequest();
            //model.paras = dto;
            //model.token = token;

            //string strParam = Newtonsoft.Json.JsonConvert.SerializeObject(model);

            //Dictionary<string, object> dicParam = new Dictionary<string, object>();
            //// 第一个接口参数，json格式字符串
            //dicParam.Add("params", strParam);

            //// 文件内容
            //byte[] file = Convert.FromBase64String("");
            //// 文件名称
            //string fileName = "fileName";
            //// 构造字典文件数据
            //// 接口参数名称为files
            //CFormUpload.FileParameter fileParameter = new CFormUpload.FileParameter("files", file, fileName, null);
            //dicParam.Add(fileName, fileParameter);

            //string strUrl = configProvince.HuiJu+ "get_case_material_info";
            //// 上传附件
            //string strResult = CFormUpload.MultipartFormDataPost(strUrl, null, dicParam, strToken);

            //var job = Newtonsoft.Json.JsonConvert.DeserializeObject<ProvinceResponse>(strResult);
            //if ("1" == job.ReturnInfo.Code)
            //{
            //    //成功
            //}
            return "";
        }

        /// <summary>
        /// 测试推送
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        [HttpPost("getcaseresultreceive")]
        [AllowAnonymous]
        public async Task<string> GetCaseResultReceive([FromBody] DateTime? dto)
        {

            await _capPublisher.PublishAsync("test", dto, cancellationToken: HttpContext.RequestAborted);

            //await _capPublisher.PublishAsync(Hotline.Share.Mq.EventNames.HotlineKnowledgeInfoUpdate, dto, cancellationToken: HttpContext.RequestAborted);

            //await _capPublisher.PublishAsync(Hotline.Share.Mq.EventNames.HotlineKnowledgeInfoAbandon, dto, cancellationToken: HttpContext.RequestAborted);
            //var data = _mapper.Map<GetKnowledgeInfoSend>(dto);

            ////将上报信息写入本地库
            //var id = await _getKnowledgeInfoSendRepository.AddAsync(data);

            //data.Id = id;
            ////信息上报
            //await _mediator.Publish(new GetKnowledgeInfoSendNotification(data));
            return "";
            //var data = _mapper.Map<GetCaseResultReceive>(dto);

            //var pusher = _pusherProvider.CreatePusher(_channelConfigurationManager);


            //var request = new GetKnowledgeInfoSendRequest();
            //request.SetData(dto);

            //var response = await pusher.PushGetKnowledgeInfoSendAsync(request, cancellationToken: default);

            //return response.Description;

            //将上报信息写入本地库
            // await _getCaseResultReceiveRepository.AddAsync(data);
            // await _mediator.Publish(new OrderCreatedNotification(new Orders.DataOrder()));
            //信息上报
            //await _mediator.Publish(new GetCaseResultReceiveNotification(data));
            // await _capPublisher.PublishAsync("GetCaseResultReceive", dto, cancellationToken: HttpContext.RequestAborted);
        }
    }
}
