﻿using Sharing.Share.Dtos.DataExchange;
using SqlSugar;
using XF.Domain.Repository;

namespace Sharing.Enterprise
{
    public class ReceiveWriteResult : CreationModificationEntity
    {
        /// <summary>
        /// 工单编号，唯一标识
        /// </summary>
        [SugarColumn(ColumnDescription = "工单编号，唯一标识", ColumnDataType = "varchar(50)")]
        public string ReplyCode { get; set; }

        /// <summary>
        /// 回复日期
        /// </summary>
        [SugarColumn(ColumnDescription = "回复日期")]
        public DateTime? ReplyDate { get; set; }

        /// <summary>
        /// 回复人
        /// </summary>
        [SugarColumn(ColumnDescription = "回复人", ColumnDataType = "varchar(8)")]
        public string ReplyUserName { get; set; }

        /// <summary>
        /// 回复部门
        /// </summary>
        [SugarColumn(ColumnDescription = "回复部门", ColumnDataType = "varchar(20)")]
        public string ReplyBMName { get; set; }

        /// <summary>
        /// 回复详情
        /// </summary>
        [SugarColumn(ColumnDescription = "回复详情", ColumnDataType = "varchar(50)")]
        public string ReplyContent { get; set; }

        /// <summary>
        /// 0:办理中 1:办理完成 2:办理退回
        /// </summary>
        [SugarColumn(ColumnDescription = "企业CODE")]
        public int ReplyResultType { get; set; }

        /// <summary>
        /// 附件
        /// </summary>
        [SugarColumn(ColumnDescription = "附件", ColumnDataType = "json", IsJson = true, IsNullable = true)]
        public List<ReplyFiles>? ReplyFiles { get; set; }
    }
}
